490    CLEAR SCREEN
500   ! MAIN ******************************************************
510   !
520    GOSUB Constants
530    GOSUB Setting
540    GOSUB Cal_setting
550    GOSUB Pi_cal
560    CLEAR SCREEN
570    GOSUB Set_watt
580    GOSUB Set_watt_list
590    GOSUB Set_phase_track
600    GOSUB Start_loop
610    STOP
620   !
630   ! DECLARE CONSTANTS *****************************************
640 Constants:  !
650    Z0=12.5
660   !
670    Ci=10           ! FOR dBm<->Watt CONVERSION
680    W_min=.01       ! START POWER [uW]
690    W_max=100       ! STOP POWER [uW]
700    Ifbw=500       ! IFBW FOR TRACKING
710    Tgt_phas=0      ! TARGET PHASE FOR TRACKING
720    Track_num=2     ! NUMBER OF TIMES TO MEASURE
730    P_nop=50        ! POWER STEP
740    Tgt_limit=8     !
750   !
760    Srch_rng=1000   ! ppm
770    Srch_mode=2      ! SRCHFR Mode (NORMAL)
780    Srch_wait=0      ! SRCHFR Wait Time
790    Fr_trg=4.E+7    ! Target Fr
800   !
810    RETURN
820   !
830   ! INSTRUMENT SETUP ******************************************
840 Setting:  !
850    ASSIGN @E5100 TO 800
860    OUTPUT @E5100;"PRES"
870    OUTPUT @E5100;"CHAN1;MEAS AR;ANAMODE ZTRAN"
880    OUTPUT @E5100;"HOLD"
890    OUTPUT @E5100;"COUC OFF"
900    OUTPUT @E5100;"IFBW ";Ifbw
910    OUTPUT @E5100;"POIN ";P_nop*2
920    OUTPUT @E5100;"FMT MAGZDF"
930    OUTPUT @E5100;"MULC OFF;SPLD ON;DISAHIHB"
940    OUTPUT @E5100;"SETZ ";Z0
950    RETURN
960   !
970 Cal_setting: !
980    OUTPUT @E5100;"SWPT LINF"
990    OUTPUT @E5100;"CENT ";Fr_trg
1000   OUTPUT @E5100;"SPAN ";Srch_rng*1.E-6*Fr_trg
1010   OUTPUT @E5100;"POWE ";0
1020   RETURN
1030  !
1040 Pi_cal: !
1050   OUTPUT @E5100;"PTRACK OFF"
1060   PRINT TABXY(0,11);"PERFORM PI-CAL"
1070   INPUT "CONNECT OPEN, THEN PRESS ENTER",Tmp$
1080   OUTPUT @E5100;"CALI ONEP;CLASS11A?"
1090   ENTER @E5100;Tmp
1100   INPUT "CONNECT SHORT, THEN PRESS ENTER",Tmp$
1110   OUTPUT @E5100;"CLASS11B?"
1120   ENTER @E5100;Tmp
1130   INPUT "CONNECT LOAD, THEN PRESS ENTER",Tmp$
1140   OUTPUT @E5100;"CLASS11C?"
1150   ENTER @E5100;Tmp
1160   OUTPUT @E5100;"SAV1?"
1170   ENTER @E5100;Tmp
1180   RETURN
1190  !
1200 Set_watt: !
1210   OUTPUT @E5100;"SWPT POWE"
1220   OUTPUT @E5100;"LISDOBASE;SWED UP"
1230   OUTPUT @E5100;"ATTW .002"
1240   OUTPUT @E5100;"POWU WATT;PICIRC ON"
1250   OUTPUT @E5100;"CIVAL ";Ci
1260   RETURN
1270  !
1280  ! SETTING POWER LIST (WATT) *********************************
1290 Set_watt_list: !
1300   ALLOCATE Pwr(1:2*P_nop)
1310   P_min=W_min*1.E-6
1320   P_max=W_max*1.E-6
1330   OUTPUT @E5100;"STAS ";P_min,P_max
1340   P_step=(P_max-P_min)/(P_nop-1)
1350   K=2*P_nop
1360   FOR I=1 TO P_nop
1370     P=P_min+P_step*(I-1)
1380     Pwr(I)=P
1390     Pwr(K)=P
1400     K=K-1
1410   NEXT I
1420   OUTPUT @E5100;"STIM";Pwr(*)
1430   OUTPUT @E5100;"CWFREQ ";Fr_trg
1440   RETURN
1450  !
1460  ! PHASE TRACKING SETTING ************************************
1470 Set_phase_track: !
1480   OUTPUT @E5100;"PTFR ";Fr_trg
1490   OUTPUT @E5100;"PTFRSR ";Srch_rng*Fr_trg*1.E-6
1500   OUTPUT @E5100;"PTTRGLMT ";Tgt_limit
1510   OUTPUT @E5100;"PTABORT ON"
1520   OUTPUT @E5100;"PTTRGPHS ";Tgt_phas
1530   OUTPUT @E5100;"PTREPN ";Track_num
1540   OUTPUT @E5100;"PTRACK ON"! TRACKING MODE ON
1550   RETURN
1560  !
1570  ! SEARCH "ACTUAL" FR ****************************************
1580 Start_loop: !
1590   LOOP
1600     INPUT "CONNECT DEVICE, THEN PRESS ENTER",Dum$
1610     BEEP
1620     OUTPUT @E5100;"SRCHFR? ";Srch_mode,Srch_wait
1630     ENTER @E5100;Srched_fr,Ci,Pt_param
1640     IF Srched_fr=-1 THEN
1650       PRINT TABXY(0,10),"Fr Search FAILED  "
1660       BEEP
1670       BEEP
1680       GOTO Prompt
1690     END IF
1700  !
1710  ! DLD CHARACTERISTICS MEASUREMENT ***************************
1720  !
1730     OUTPUT @E5100;"PTFR ";Srched_fr
1740     OUTPUT @E5100;"PTPARA ";Pt_param
1750     OUTPUT @E5100;"SING?"
1760     ENTER @E5100;Dummy
1770  !
1780     OUTPUT @E5100;"PTSTAT?"
1790     ENTER @E5100;Result
1800     IF Result=0 THEN
1810       BEEP
1820       BEEP
1830       PRINT TABXY(0,10),"Phase Track FAILED"
1840       GOTO Prompt
1850     END IF
1860  !
1870     GOSUB Analysis
1880  !
1890     GOSUB Printing
1900  !
1910 Prompt:    !
1920   END LOOP
1930  !
1940 Analysis: ! DATA ANALYSIS
1950   OUTPUT @E5100;"ANARFULL"
1960   OUTPUT @E5100;"ANAOMEMO"
1970   OUTPUT @E5100;"OUTPMINMAX?"
1980   ENTER @E5100;Min_df,Mindf_p,Max_df,Maxdf_p
1990   OUTPUT @E5100;"ANAODATA"
2000   OUTPUT @E5100;"OUTPMINMAX?"
2010   ENTER @E5100;Min_z,Min_zp,Max_z,Max_zp
2020   RETURN
2030  !
2040 Printing: ! PRINTING ROUTINE
2050   PRINT TABXY(0,1)
2060   PRINT USING "27A,5X,3D.9D,X,5A";"RESONANT FREQ at MIN power",Srched_fr*1.E-6,"(MHz)"
2070   PRINT USING "11A,2X,6A,X,4Z.2D,X,6A,3X,6A,X,4Z.3D,X,5A";"DELTA FREQ:","[MIN]",Min_df,"(Hz)","[MAX]",Max_df,"(Hz)"
2080   PRINT USING "X,10A,2X,5A,2X,3Z.2D,X,5A,5X,5A,2X,3Z.2D,X,5A";"IMPEDANCE:","[MIN]",Min_z,"(ohm)","[MAX]",Max_z,"(ohm)"
2090   !
2100   PRINT TABXY(0,6)
2110   PRINT USING "5A,X,4A,4X,10A,X,5A,2X,20A,X,4A";"POWER","(uW)","RESISTANCE","(ohm)","FREQUENCY DIFFERENCE","(Hz)"
2120   FOR I=1 TO 3
2130     Point=10^(I-1)
2140     OUTPUT @E5100;"OUTPFORMP? ";Point
2150     ENTER @E5100;Z,Df
2160     PRINT USING "X,4D.4D,11X,3D.2D,12X,4D.3D";Pwr(Point)*1.E+6,Z,Df
2170   NEXT I
2180   PRINT TABXY(0,10),"                       "
2190  !
2200   RETURN
2210  !
2220  END
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent E5100A/B Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      05/01/2008
5050   !* PROGRAM NAME: SMPL023.BAS
5060   !* REVISION:     A.01.11
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************